<?php
/* @var $this PropertiesInput */
?>
<div class="form-horizontal small" data-bind="foreach: <?php echo $this->src;?>">
    <div class="form-group" data-bind="hidden: $data.hidden">
        <label class="col-sm-4 control-label" data-bind="text: name, attr :{ for: 'item'+$index()}"></label>
        <div class="col-sm-8" data-bind="template: 'input_' + ko.unwrap(type)"></div>        
    </div>
</div>
<?php
if ( PropertiesInput::$firstUse ){
    PropertiesInput::$firstUse = false;
    ob_start();    
?>
<script type="text/html" id="input_string">
    <input class='form-control input-sm' <?php if ( $this->disabled ) echo "disabled";?> data-bind="value: value, attr: { id: 'item_'+$index(), placeholder: $data.default}"/>
</script>
<script type="text/html" id="input_number">
    <input class='form-control input-sm' <?php if ( $this->disabled ) echo "disabled";?> data-bind="value: value, attr: { id: 'item'+$index(), placeholder: $data.default}"/>
</script>
<script type="text/html" id="input_slider">
    <input class='form-control input-sm' <?php if ( $this->disabled ) echo "disabled";?> data-bind="slider: $data, attr: { id: 'item'+$index()}"/>
</script>
<script type="text/html" id="input_text">
    <textarea class="form-control input-sm" style="resize: vertical; min-height: 26px" rows="3" <?php if ( $this->disabled ) echo "disabled";?>  data-bind="value: value, attr: { id: 'item'+$index(), placeholder: $data['default']}"></textarea>            
</script>
<script type="text/html" id="input_time">
    <input class='form-control input-sm' <?php if ( $this->disabled ) echo "disabled";?> data-bind="mask: '9{1,2}:99', value: value, attr: { id: 'item'+$index(), placeholder: $data.default}"/>
</script>
<script type="text/html" id="input_dur">
    <input class='form-control input-sm' <?php if ( $this->disabled ) echo "disabled";?> data-bind="duration: value, attr: { id: 'item_'+$index(), placeholder: $data.default || 'e.g. 12h 30m or 10s'}"/>
</script>
<script type="text/html" id="input_tags">
    <input class='' <?php if ( $this->disabled ) echo "disabled";?> data-bind="tags: value, tagsOptions: options, attr: { id: 'item_'+$index()}"/><br/><br/>
</script>
<script type="text/html" id="input_date">
    <div class="input-group date" data-bind="datepicker: value, attr: { id: 'item_'+$index()}, datepickerOptions: { pickerPosition: 'bottom-left', language: '<?php echo Yii::app()->getLanguage();?>'}">        
        <input class='form-control input-sm' readonly <?php if ( $this->disabled ) echo "disabled";?> />
        <div class="input-group-addon"><i class="glyphicon-calendar fa fa-calendar"></i></div>        
    </div>
</script>
<script type="text/html" id="input_dateclose">
    <div class="input-group date" data-bind="datepicker: value, attr: { id: 'item_'+$index()}, datepickerOptions: { pickerPosition: 'bottom-left', language: '<?php echo Yii::app()->getLanguage();?>'}">        
        <input class='form-control input-sm' readonly <?php if ( $this->disabled ) echo "disabled";?> />
        <div class="input-group-addon"><i class="glyphicon-calendar fa fa-calendar"></i></div>        
        <div class="input-group-addon"><i class="glyphicon-remove fa fa-remove"></i></div>        
    </div>
</script>
<script type="text/html" id="input_datetime">
    <div class='row'>
        <div class='col-sm-6' data-bind="hidden: $data.hiddenDate">
            <div class="input-group date" data-bind="datepicker: date, attr: { id: 'item_'+$index()}, datepickerOptions: { pickerPosition: 'bottom-left', language: '<?php echo Yii::app()->getLanguage();?>'}">        
                <input class='form-control input-sm' readonly <?php if ( $this->disabled ) echo "disabled";?> />
                <div class="input-group-addon"><i class="glyphicon-calendar fa fa-calendar"></i></div>        
            </div>
        </div>
        <div class='col-sm-6' data-bind="hidden: $data.hiddenTime">
            <input class='form-control input-sm' <?php if ( $this->disabled ) echo "disabled";?> data-bind="mask: '9{1,2}:99', value: time"/>
        </div>
    </div>
</script>
<script type="text/html" id="input_boolean">
    <input type="checkbox" class='form-control input-sm btn-sm' <?php if ( $this->disabled ) echo "disabled";?> data-bind="
                iCheck: value,
                attr:{
                    'data-on-label': $data.true || 'yes',
                    'data-off-label': $data.false || 'no'
                }"/>
</script>
<script type="text/html" id="input_choice">
    <select class="form-control" data-style="btn-default" <?php if ( $this->disabled ) echo "disabled";?> data-bind="bootstrapSelect: value, 
            options: select, optionsText: 'name', optionsValue: 'value'">
    </select> 
</script>
<script type="text/html" id="input_timezones">
    <select class="" data-style="btn-default" <?php if ( $this->disabled ) echo "disabled";?> data-bind="timezonepicker: value" ></select> 
</script>
<script type="text/html" id="input_locales">
    <select class="" data-style="btn-default" <?php if ( $this->disabled ) echo "disabled";?> data-bind="localepicker: value" ></select> 
</script>
<script type="text/html" id="input_multichoice">
    <select class="form-control" multiple="multiple" data-style="btn-default" <?php if ( $this->disabled ) echo "disabled";?> data-bind="multiselect: value, selectOptions: $data.options, 
            options: select, optionsText: 'name', optionsValue: 'value'">
    </select>
</script>
<script type="text/html" id="input_color">
    <div class="input-group input-group-sm" data-bind="colorpicker: value, default: $data.default">
        <span class="input-group-addon"><i></i></span>
        <input class='form-control' placeholder='pick a color' <?php if ( $this->disabled ) echo "disabled";?> data-bind="attr:{ placeholder: $data.default }"/>
    </div> 
</script>
<script type="text/html" id="input_color_opacity">
    <div class='row'>
        <div class='col-sm-6'>
            <div class="input-group input-group-sm" data-bind="colorpicker: value, default: $data.default">
                <span class="input-group-addon"><i></i></span>
                <input class='form-control' placeholder='pick a color' <?php if ( $this->disabled ) echo "disabled";?> data-bind="attr:{ placeholder: $data.default }"/>
            </div>            
        </div>
        <div class='col-sm-6'>
            <input class='form-control input-sm' <?php if ( $this->disabled ) echo "disabled";?> data-bind="slider: opacity"/>
        </div>
    </div>
    
</script>
<script type="text/html" id="input_apps">
    <input class='form-control input-sm disabled' disabled='disabled' data-bind="value: details, attr: { id: 'item_'+$index()}"/>
</script>
<script type="text/html" id="input_link">
    <div class="input-group input-group-sm">
      <input class='form-control' readonly="readonly" data-bind="value: value, attr: { id: 'item_'+$index()}"/>
      <span class="input-group-btn">
        <a class='btn btn-default btn-sm' target='_blank' data-bind="attr: { id: 'item_'+$index(), href: value}"><?php echo I18N::ht("Open");?></a>
      </span>
    </div><!-- /input-group -->
</script>
<?php
    $template = ob_get_contents ( );
    ob_end_clean();
    $this->controller->registerTemplates( $template );
}